# Getting support for Composr CMS #

## Support resources ##

The primary place for support is the [forum](https://composr.app/forum).
We also have the IRC room, which is the #composrcms channel on FreeNode.

Companies may provide commercial support services, and may list their services on the [Composr website](https://composr.app/).

## Rights and responsibilities ##

Composr CMS is an Open Source software project, provided for free.
To that end, free support is not a right and cannot be guaranteed. It is the responsibility of users to secure whatever arrangements they need to support their ambitions.

If you require free support from others, bear these things in mind:
1. Be the change you want to see. If you think people should be helping each other out with free support, actively provide free support yourself. Set an example. Answer questions on the forum. Stay connected to the IRC channel. You cannot expect others to help more so than you are doing yourself.
2. Make it easy for people to help you. Go out of your way to make your questions and situation as clear as possible, so those helping you can do so as quickly as possible, preferably without any back and forth. Put a higher value on the time of those helping you than your own time.
3. Active participation in the community is likely to forge relationships that will help you when you are in need. It's a family, or if you prefer, it's an implicit version of "you scratch my back, I scratch yours".
4. If you can, support key people in the community financially. The [community stars](https://composr.app/stars.htm) page lists ways to do that. If community members are funded, they can pour more time into what they are doing. For example, maybe Sue can pay someone to mow her lawn and spend more time helping others out if she has Patreon money coming in each month.

Everyone in the community should make a reasonable good faith effort to use official channels and documented procedures, so that things are done in the open in a way that is easy for stakeholders to manage.

The maintainers of Composr CMS do make a commitment (in good faith, but not legally binding) to:
1. Respond (&dagger;) to any bug report submitted to the tracker within 30 days (bug reports, not feature suggestions)
2. Respond (&dagger;) to any merge request on GitLab within 30 days
3. Fix security issues within a month
4. Operate with the principle that something that makes the project better, so long as it doesn't break key considerations, should be accepted even if it is not absolutely perfect (a project with strong foundations is better off taking in new ideas from enthusiastic people than trying to do idealistic centralised top-down planning)
5. Not be overly pedantic: while we have a long list of coding standards, and extensive details on how best to report issues, we won't criticise submissions for not being perfect if the submitter is operating in good faith and not causing actual harm -- instead we will help guide people, or contribute improvements ourselves
6. Operate as per the [code of conduct](CODE_OF_CONDUCT.md)

&dagger; Responding isn't the same as concluding. No guarantees are made about when things may be concluded, or what may be accepted into the project by the maintainers.

As a community, the Composr CMS developers expect to continue developing the platform with improvements over time. Any timeline, or what particular improvements consist of, is up to these contributors and maintainers.
The most reliable way of moving the project forward in the way you want is to contribute your own improvements or pay people to do so.

## Reporting issues (including bugs and feature suggestions) ##

We have an extensive tutorial, [Problem and feedback reports, and development policies](https://composr.app/docs/tut-software-feedback.htm).
Basically, issues are submitted to [the tracker](https://composr.app/tracker).
