<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    random_quotes
 */

/**
 * Hook class.
 */
class Hook_notes_quotes
{
    /**
     * Decaching trigger for main_notes saves. See if we have to decache based on the passed filename.
     *
     * @param  PATH $file Filename
     */
    public function run(string $file)
    {
        if (!addon_installed('random_quotes')) {
            return;
        }

        if ((strpos($file, '/quotes') !== false) || ($file == 'quotes')) {
            delete_cache_entry('main_quotes');
        }
    }
}
