<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    downloads
 */

/**
 * Hook class.
 */
class Hook_gu_downloads
{
    /**
     * Add in new icons to a worked-within gallery.
     *
     * @param  ID_TEXT $cat Gallery name
     * @return array Results
     */
    public function new_donext_icons(string $cat) : array
    {
        if (!addon_installed('downloads')) {
            return [];
        }

        if (substr($cat, 0, 9) != 'download_') {
            return [];
        }

        $id = intval(substr($cat, 9));
        return [
            ['menu/rich_content/downloads', ['downloads', ['type' => 'entry', 'id' => $id], get_module_zone('downloads')], do_lang('VIEW')],
        ];
    }
}
