<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    calendar
 */

/**
 * Hook class.
 */
class Hook_members_calendar
{
    /**
     * Find member-related links to inject to details section of the about tab of the member profile.
     *
     * @param  MEMBER $member_id The ID of the member we are getting links for
     * @return array List of pairs: title to value
     */
    public function run(int $member_id) : array
    {
        if (!addon_installed('calendar')) {
            return [];
        }

        //if (!has_privilege(get_member(), 'assume_any_member')) return [];  Now will have separate permission filtering
        if (!has_actual_page_access(get_member(), 'calendar', get_module_zone('calendar'))) {
            return [];
        }

        require_lang('calendar');
        return [['content', do_lang_tempcode('CALENDAR'), build_url(['page' => 'calendar', 'type' => 'browse', 'member_id' => $member_id, 'private' => 1], get_module_zone('calendar')), 'menu/rich_content/calendar']];
    }
}
