<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    news
 */

/**
 * Hook class.
 */
class Hook_members_news
{
    /**
     * Find member-related links to inject to details section of the about tab of the member profile.
     *
     * @param  MEMBER $member_id The ID of the member we are getting links for
     * @return array List of pairs: title to value
     */
    public function run(int $member_id) : array
    {
        if (!addon_installed('news')) {
            return [];
        }

        $nc_id = $GLOBALS['SITE_DB']->query_select_value_if_there('news_categories', 'id', ['nc_owner' => $member_id]);
        if ($nc_id !== null) {
            require_lang('news');
            $modules = [];
            if (has_actual_page_access(get_member(), 'news', get_page_zone('news'))) {
                $modules[] = ['content', do_lang_tempcode('BLOG_NEWS_ARCHIVE'), build_url(['page' => 'news', 'type' => 'browse', 'id' => $nc_id, 'blog' => 1], get_module_zone('news')), 'menu/cms/blog'];
            }
            return $modules;
        }
        return [];
    }
}
