<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    cns_cpfs
 */

/**
 * Hook class.
 */
class Hook_actionlog_cns_cpfs extends Hook_actionlog
{
    /**
     * Get details of action log entry types handled by this hook.
     *
     * @return array Map of handler data in standard format
     */
    public function get_handlers() : array
    {
        if (get_forum_type() != 'cns') {
            return [];
        }

        if (!addon_installed('cns_cpfs')) {
            return [];
        }

        require_lang('cns');

        return [
            'ADD_CUSTOM_PROFILE_FIELD' => [
                'flags' => ACTIONLOG_FLAGS_NONE,
                'cma_hook' => 'cpf',
                'identifier_index' => 0,
                'written_context_index' => 1,
                'followup_page_links' => [
                    'EDIT_THIS_CUSTOM_PROFILE_FIELD' => '_SEARCH:admin_cns_customprofilefields:_edit:{ID}',
                    'ADD_CUSTOM_PROFILE_FIELD' => '_SEARCH:admin_cns_customprofilefields:add',
                ],
            ],
            'EDIT_CUSTOM_PROFILE_FIELD' => [
                'flags' => ACTIONLOG_FLAGS_NONE,
                'cma_hook' => 'cpf',
                'identifier_index' => 0,
                'written_context_index' => 1,
                'followup_page_links' => [
                    'EDIT_THIS_CUSTOM_PROFILE_FIELD' => '_SEARCH:admin_cns_customprofilefields:_edit:{ID}',
                    'ADD_CUSTOM_PROFILE_FIELD' => '_SEARCH:admin_cns_customprofilefields:add',
                ],
            ],
            'DELETE_CUSTOM_PROFILE_FIELD' => [
                'flags' => ACTIONLOG_FLAGS_NONE,
                'cma_hook' => 'cpf',
                'identifier_index' => 0,
                'written_context_index' => 1,
                'followup_page_links' => [
                    'ADD_CUSTOM_PROFILE_FIELD' => '_SEARCH:admin_cns_customprofilefields:add',
                ],
            ],
        ];
    }
}
