<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    polls
 */

/**
 * Hook class.
 */
class Hook_actionlog_polls extends Hook_actionlog
{
    /**
     * Get details of action log entry types handled by this hook.
     *
     * @return array Map of handler data in standard format
     */
    public function get_handlers() : array
    {
        if (!addon_installed('polls')) {
            return [];
        }

        require_lang('polls');

        return [
            'ADD_POLL' => [
                'flags' => ACTIONLOG_FLAGS_NONE,
                'cma_hook' => 'poll',
                'identifier_index' => 0,
                'written_context_index' => 1,
                'followup_page_links' => [
                    'VIEW' => '_SEARCH:polls:view:{ID}',
                    'EDIT_THIS_POLL' => '_SEARCH:cms_polls:_edit:{ID}',
                    'ADD_POLL' => '_SEARCH:cms_polls:add',
                ],
            ],
            'EDIT_POLL' => [
                'flags' => ACTIONLOG_FLAGS_NONE,
                'cma_hook' => 'poll',
                'identifier_index' => 0,
                'written_context_index' => 1,
                'followup_page_links' => [
                    'VIEW' => '_SEARCH:polls:view:{ID}',
                    'EDIT_THIS_POLL' => '_SEARCH:cms_polls:_edit:{ID}',
                    'ADD_POLL' => '_SEARCH:cms_polls:add',
                ],
            ],
            'CHOOSE_POLL' => [
                'flags' => ACTIONLOG_FLAGS_NONE,
                'cma_hook' => 'poll',
                'identifier_index' => 0,
                'written_context_index' => 1,
                'followup_page_links' => [
                    'VIEW' => '_SEARCH:polls:view:{ID}',
                    'EDIT_THIS_POLL' => '_SEARCH:cms_polls:_edit:{ID}',
                    'ADD_POLL' => '_SEARCH:cms_polls:add',
                ],
            ],
            'DELETE_POLL' => [
                'flags' => ACTIONLOG_FLAGS_NONE,
                'cma_hook' => 'poll',
                'identifier_index' => 0,
                'written_context_index' => 1,
                'followup_page_links' => [
                    'ADD_POLL' => '_SEARCH:cms_polls:add',
                ],
            ],
        ];
    }
}
