<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    core_cleanup_tools
 */

/**
 * Hook class.
 */
class Hook_cleanup_sitemap
{
    /**
     * Find details about this cleanup hook.
     *
     * @return ?array Map of cleanup hook info (null: hook is disabled)
     */
    public function info() : ?array
    {
        if ($GLOBALS['CURRENT_SHARE_USER'] !== null) {
            return null;
        }

        $info = [];
        $info['title'] = do_lang_tempcode('REBUILD_SITEMAP');
        $info['description'] = do_lang_tempcode('DESCRIPTION_REBUILD_SITEMAP');
        $info['type'] = 'cache';

        return $info;
    }

    /**
     * Run the cleanup hook action.
     *
     * @return Tempcode Results
     */
    public function run() : object
    {
        require_code('tasks');
        call_user_func_array__long_task(do_lang('REBUILD_SITEMAP'), get_screen_title('REBUILD_SITEMAP'), 'sitemap', [true]);

        return new Tempcode();
    }
}
