<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    health_check
 */

/**
 * Hook class.
 */
class Hook_config_hc_mail_wait_time
{
    /**
     * Gets the details relating to the config option.
     *
     * @return ?array The details (null: disabled)
     */
    public function get_details() : ?array
    {
        return [
            'human_name' => 'HC_MAIL_WAIT_TIME',
            'type' => 'integer',
            'category' => 'HEALTH_CHECK',
            'group' => '_EMAIL',
            'explanation' => 'CONFIG_OPTION_hc_mail_wait_time',
            'shared_hosting_restricted' => '0',
            'list_options' => '',
            'required' => true,
            'order_in_category_group' => 7,
            'public' => false,
            'addon' => 'health_check',
        ];
    }

    /**
     * Gets the default value for the config option.
     *
     * @return ?string The default value (null: option is disabled)
     */
    public function get_default() : ?string
    {
        if (!addon_installed('health_check')) {
            return null;
        }

        if (!function_exists('imap_open') && !addon_installed('imap')) {
            return null;
        }

        return '120';
    }
}
