<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    core_rich_media
 */

/**
 * Hook class.
 */
class Hook_config_oembed_html_safelist
{
    /**
     * Gets the details relating to the config option.
     *
     * @return ?array The details (null: disabled)
     */
    public function get_details() : ?array
    {
        return [
            'human_name' => 'OEMBED_HTML_SAFELIST',
            'type' => 'text',
            'category' => 'CONTENT_EDITING',
            'group' => 'MEDIA',
            'explanation' => 'CONFIG_OPTION_oembed_html_safelist',
            'shared_hosting_restricted' => '0',
            'list_options' => '',
            'order_in_category_group' => 4,
            'required' => false,
            'public' => false,
            'addon' => 'core_rich_media',
        ];
    }

    /**
     * Gets the default value for the config option.
     *
     * @return ?string The default value (null: option is disabled)
     */
    public function get_default() : ?string
    {
        return "youtube.com\nyoutu.be\nvimeo.com\ndailymotion.com\nslideshare.net\nscribd.com\nsoundcloud.com\ntwitter.com\ninstagram.com\nembed.ly\nmaps.bing.com\nmaps.google.com\nmaps.google.co.uk\nimgur.com\nustream.tv\njustin.tv\napi.embed.ly\nnoembed.com\nfacebook.com";
    }
}
