<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    core_rich_media
 */

/**
 * Hook class.
 */
class Hook_config_oembed_max_size
{
    /**
     * Gets the details relating to the config option.
     *
     * @return ?array The details (null: disabled)
     */
    public function get_details() : ?array
    {
        return [
            'human_name' => 'OEMBED_MAX_SIZE',
            'type' => 'integer',
            'category' => 'CONTENT_EDITING',
            'group' => 'MEDIA',
            'explanation' => 'CONFIG_OPTION_oembed_max_size',
            'shared_hosting_restricted' => '0',
            'list_options' => '',
            'order_in_category_group' => 6,
            'required' => true,
            'public' => false,
            'addon' => 'core_rich_media',
        ];
    }

    /**
     * Gets the default value for the config option.
     *
     * @return ?string The default value (null: option is disabled)
     */
    public function get_default() : ?string
    {
        return '200'; // A good example of a wide thing is an embedded Tweet
    }
}
