<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    core_privacy
 */

/**
 * Hook class.
 */
class Hook_logs_core
{
    /**
     * Find supported logs.
     *
     * @return array List of logs
     */
    public function enumerate_logs() : array
    {
        return [
            'errorlog.php' => ['days_to_keep' => (get_option('days_to_keep__error_log') == '') ? null : intval(get_option('days_to_keep__error_log'))],
            'cron.log' => ['days_to_keep' => (get_option('days_to_keep__cron_log') == '') ? null : intval(get_option('days_to_keep__cron_log'))],
            'tasks.log' => ['days_to_keep' => (get_option('days_to_keep__tasks_log') == '') ? null : intval(get_option('days_to_keep__tasks_log'))],
            'permission_checks.log' => ['days_to_keep' => (get_option('days_to_keep__permission_checks_log') == '') ? null : intval(get_option('days_to_keep__permission_checks_log'))],
            'queries.log' => ['days_to_keep' => (get_option('days_to_keep__queries_log') == '') ? null : intval(get_option('days_to_keep__queries_log'))],
            'mail_integration.log' => ['days_to_keep' => (get_option('days_to_keep__mail_integration_log') == '') ? null : intval(get_option('days_to_keep__mail_integration_log'))],
            'debug_fs.log' => ['days_to_keep' => (get_option('days_to_keep__debug_fs_log') == '') ? null : intval(get_option('days_to_keep__debug_fs_log'))],
            'require_code.log' => ['days_to_keep' => (get_option('days_to_keep__require_code_log') == '') ? null : intval(get_option('days_to_keep__require_code_log'))],
            'banned_access.log' => ['days_to_keep' => (get_option('days_to_keep__banned_access_log') == '') ? null : intval(get_option('days_to_keep__banned_access_log'))],
        ];
    }
}
