<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    custom_comcode
 */

/**
 * Hook class.
 */
class Hook_snippet_exists_tag
{
    /**
     * Run function for snippet hooks. Generates HTML to insert into a page using AJAX.
     *
     * @return Tempcode The snippet
     */
    public function run() : object
    {
        if (!addon_installed('custom_comcode')) {
            return new Tempcode();
        }

        $tag = get_param_string('name');

        require_code('comcode_compiler');

        init_valid_comcode_tags();

        global $VALID_COMCODE_TAGS;
        $test = $GLOBALS['SITE_DB']->query_select_value_if_there('custom_comcode', 'tag_tag', ['tag_tag' => $tag]);
        if ((array_key_exists($tag, $VALID_COMCODE_TAGS)) || ($test !== null)) {
            return make_string_tempcode(strip_html(do_lang('ALREADY_EXISTS', escape_html($tag))));
        }

        return new Tempcode();
    }
}
