<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    core_cns
 */

/**
 * Hook class.
 */
class Hook_snippet_pt_rules
{
    /**
     * Run function for snippet hooks. Generates HTML to insert into a page using AJAX.
     *
     * @return Tempcode The snippet
     */
    public function run() : object
    {
        $username = get_param_string('username');
        $member_id = $GLOBALS['FORUM_DRIVER']->get_member_from_username($username);
        if ($member_id === null) {
            return make_string_tempcode('-1');
        }

        require_code('cns_members2');
        if (!cns_may_whisper($member_id)) {
            return make_string_tempcode('-2');
        }

        $member_row = $GLOBALS['FORUM_DRIVER']->get_member_row($member_id);
        $just_member_row = db_map_restrict($member_row, ['id', 'm_pt_rules_text']);
        $rules = get_translated_tempcode('f_members', $just_member_row, 'm_pt_rules_text', $GLOBALS['FORUM_DB']);
        if (trim($rules->evaluate()) == '') {
            return new Tempcode();
        }
        return $rules;
    }
}
