<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    stats
 */

/**
 * Hook class.
 */
class Hook_symbol_SPLIT_TEST
{
    /**
     * Run function for symbol hooks. Searches for tasks to perform.
     *
     * @param  array $param Symbol parameters
     * @return string Result
     */
    public function run(array $param) : string
    {
        if (!addon_installed('stats')) {
            return '';
        }

        $value = '';
        if (isset($param[0])) {
            $new_tracking_code = null;

            // Already have one of them active? In which case, we'll just be using that.
            $tracking_codes = find_session_tracking_codes();
            foreach ($tracking_codes as $tracking_code) {
                if (in_array($tracking_code, $param)) {
                    $new_tracking_code = $tracking_code;
                    break;
                }
            }

            // None already active so pick a random one.
            if ($new_tracking_code === null) {
                $index = array_rand($param);
                $new_tracking_code = $param[$index];
            }

            if (!in_array($new_tracking_code, $tracking_codes)) {
                // This is a bit of a FUDGE - we just change $_GET so as if the tracking code was always there!
                $_t = get_param_string('_t', '');
                if ($_t == '') {
                    $_GET['_t'] = $new_tracking_code;
                } else {
                    if (!in_array($new_tracking_code, explode(',', $_t))) {
                        $_GET['_t'] .= ',' . $new_tracking_code;
                    }
                }
            }

            $value = $new_tracking_code;
        }
        return $value;
    }
}
