<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    core
 */

/**
 * Hook class.
 */
class Hook_task_create_index
{
    /**
     * Run the task hook.
     *
     * @param  ID_TEXT $db_id The database connection identifier
     * @set FORUM_DB SITE_DB
     * @param  array $params Parameters to pass to the create_index method
     * @return ?array A tuple of at least 2: Return mime-type, content (either Tempcode, or a string, or a filename and file-path pair to a temporary file), map of HTTP headers if transferring immediately, map of ini_set commands if transferring immediately (null: show standard success message)
     */
    public function run(string $db_id, array $params) : ?array
    {
        $db = $GLOBALS[$db_id];
        call_user_func_array([$db, 'create_index'], $params);

        return null;
    }
}
