<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    core_notifications
 */

/**
 * Hook class.
 */
class Hook_task_dispatch_notification
{
    /**
     * Run the task hook.
     *
     * @param  object $dispatcher The notification dispatch object (pre-filled with details of the notification to send)
     * @param  array $csss List of CSS files to require
     * @return ?array A tuple of at least 2: Return mime-type, content (either Tempcode, or a string, or a filename and file-path pair to a temporary file), map of HTTP headers if transferring immediately, map of ini_set commands if transferring immediately (null: show standard success message)
     */
    public function run(object $dispatcher, array $csss = []) : ?array
    {
        require_code('notifications');
        require_lang('notifications');

        foreach ($csss as $css) {
            require_css($css);
        }

        $dispatcher->dispatch();

        return null;
    }
}
