<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    core
 */

/**
 * Hook class.
 */
class Hook_task_meta_tree_rebuild
{
    /**
     * Run the task hook.
     *
     * @return ?array A tuple of at least 2: Return mime-type, content (either Tempcode, or a string, or a filename and file-path pair to a temporary file), map of HTTP headers if transferring immediately, map of ini_set commands if transferring immediately (null: show standard success message)
     */
    public function run() : ?array
    {
        require_code('themes_meta_tree');
        $meta_tree_builder = new Meta_tree_builder();
        $meta_tree_builder->refresh(null, null, [$this, 'log']);

        return null;
    }

    /**
     * Do logging.
     *
     * @param  string $message Message to log
     * @param  integer $i Iterator position
     * @param  integer $total Total iterating through
     */
    public function log(string $message, int $i, int $total)
    {
        static $i = 0;

        task_log($this, $message, $i, $total);

        $i++;
    }
}
