<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    galleries
 */

/**
 * Hook class.
 */
class Hook_trackback_videos
{
    /**
     * Run function for trackback hooks. They see if content of an ID relating to this content has trackback enabled.
     *
     * @param  ID_TEXT $id The ID
     * @return boolean Whether trackback is enabled
     */
    public function run(string $id) : bool
    {
        if (!addon_installed('galleries')) {
            return false;
        }

        $rows = $GLOBALS['SITE_DB']->query_select('videos', ['allow_trackbacks'], ['id' => intval($id)], '', 1);
        if (!array_key_exists(0, $rows)) {
            return false;
        }
        return $rows[0]['allow_trackbacks'] == 1;
    }
}
