<?php /*

 Composr
 Copyright (c) Christopher Graham, 2004-2024

 See docs/LICENSE.md for full licensing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  Christopher Graham
 * @package    ecommerce
 */

/**
 * Hook class.
 */
class Hook_trusted_sites_ecommerce
{
    /**
     * Detect what needs to be 'added' to the trusted_sites_1 option.
     *
     * @param  array $sites List of trusted sites (written by reference)
     */
    public function find_trusted_sites_1(array &$sites)
    {
    }

    /**
     * Detect what needs to be 'added' to the trusted_sites_2 option.
     *
     * @param  array $sites List of trusted sites (written by reference)
     */
    public function find_trusted_sites_2(array &$sites)
    {
        if (!addon_installed('ecommerce')) {
            return;
        }

        if ((get_option('payment_gateway') == 'paypal') && (get_option('payment_gateway_username') != '')) {
            if (get_option('csp_on_forms') == '1') {
                $sites[] = 'paypal.com';
                $sites[] = 'sandbox.paypal.com';
                $sites[] = 'ipnpb.paypal.com';
                $sites[] = 'ipnpb.sandbox.paypal.com';
            }
        }

        if ((get_option('payment_gateway') == 'authorize') && (get_option('payment_gateway_username') != '')) {
            $sites[] = 'authorize.net';
            $sites[] = 'test.authorize.net';
        }

        if ((get_option('payment_gateway') == 'ccbill') && (get_option('payment_gateway_username') != '')) {
            if (get_option('csp_on_forms') == '1') {
                $sites[] = 'api.ccbill.com';
            }
        }
    }
}
